// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SME2DBF.pas' rev: 6.00

#ifndef SME2DBFHPP
#define SME2DBFHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Variants.hpp>	// Pascal unit
#include <SME2Cell.hpp>	// Pascal unit
#include <SMEEngine.hpp>	// Pascal unit
#include <ExportDS.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Sme2dbf
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TDBFField
{
	char FieldName[11];
	char FieldType;
	int Address;
	Byte Length;
	Byte Decimals;
	Byte Reserved1[2];
	Byte WordAreaID;
	Word MultiUserDBase;
	Byte SetFields;
	Byte Reserved2[8];
	Byte MDXFlag;
} ;
#pragma pack(pop)

typedef TDBFField TDBFFields[256];

#pragma option push -b-
enum TDBFVersion { dBase3, dBase3Memo, FoxPro, FoxProMemo, dBase4, dBase4Memo, VFP3 };
#pragma option pop

#pragma option push -b-
enum TDBFMemoType { dmDBT, dmFPT };
#pragma option pop

#pragma pack(push, 1)
struct TDBFHeader
{
	Byte VersionNumber;
	Byte LastUpdateYear;
	Byte LastUpdateMonth;
	Byte LastUpdateDay;
	int NumberOfRecords;
	Word HeaderSize;
	Word RecordSize;
	char Reserve1[2];
	Byte IncompleteTransaction;
	Byte Encrypted;
	char Reserved[12];
	Byte MDXIsExist;
	Byte LanguageID;
	char Reserved2[2];
	int NumberOfFields;
	TDBFField Fields[256];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TSMEDBTHeader
{
	int NextBlock;
	Byte Dummy[4];
	Byte DbfFile[8];
	Byte Version;
	Byte Dummy2[3];
	Word BlockLen;
	Byte Dummy3[490];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TSMEFPTHeader
{
	int NextBlock;
	Byte Dummy[2];
	Word BlockLen;
	Byte Dummy3[504];
} ;
#pragma pack(pop)

struct TSMEBlockHeader;
typedef TSMEBlockHeader *PSMEBlockHeader;

#pragma pack(push, 4)
struct TSMEBlockHeader
{
	int MemoType;
	int MemoSize;
} ;
#pragma pack(pop)

class DELPHICLASS TSMExportToDBF;
class PASCALIMPLEMENTATION TSMExportToDBF : public Sme2cell::TSMExportToCellFile 
{
	typedef Sme2cell::TSMExportToCellFile inherited;
	
private:
	#pragma pack(push, 1)
	TDBFHeader DBFHeader;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	TSMEDBTHeader MEMOHeader;
	#pragma pack(pop)
	
	TDBFVersion FDBFVersion;
	TDBFMemoType FDBFMemoType;
	bool MemoIsExists;
	AnsiString MemoFileName;
	
protected:
	Classes::TStream* MEMOStream;
	virtual bool __fastcall MergeIsSupported(void);
	virtual void __fastcall InternalBeforeProcess(void);
	virtual void __fastcall InternalFileCreate(const AnsiString AFileName);
	void __fastcall WriteMemo(AnsiString Value);
	
public:
	virtual void __fastcall WriteDataBegin(void);
	virtual void __fastcall CloseFileStream(void);
	virtual void __fastcall WriteDimensions(int intRowCount, int intColCount);
	virtual void __fastcall WriteColWidth(int intCurColumn, int intColWidth);
	virtual void __fastcall WriteRowStart(bool IsAddedTitle);
	virtual void __fastcall WriteData(Db::TField* fld, Smeengine::TCellType CellType, int ARow, int ACol, AnsiString AString, Classes::TAlignment al, Graphics::TFont* font, Graphics::TColor color);
	__fastcall virtual TSMExportToDBF(Classes::TComponent* AOwner);
	virtual AnsiString __fastcall Extension();
	
__published:
	__property TDBFVersion DBFVersion = {read=FDBFVersion, write=FDBFVersion, default=0};
	__property TDBFMemoType DBFMemoType = {read=FDBFMemoType, write=FDBFMemoType, default=0};
public:
	#pragma option push -w-inl
	/* TSMExportBaseComponent.Destroy */ inline __fastcall virtual ~TSMExportToDBF(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Byte arrDBFVersion[7];

}	/* namespace Sme2dbf */
using namespace Sme2dbf;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SME2DBF
